玩命加载中 . . .

组合总和


描述

给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。

candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。

对于给定的输入,保证和为 target 的不同组合数少于 150 个。

示例 1:

输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。
示例 2:

输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:

输入: candidates = [2], target = 1
输出: []

提示:

1 <= candidates.length <= 30
2 <= candidates[i] <= 40
candidates 的所有元素 互不相同
1 <= target <= 40

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/combination-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

题解

C++代码

class Solution {
public:
    vector<vector<int>> combinationSum(vector<int>& candidates, int target) {
        vector<vector<int>> res; // 存放结果的数组
        vector<int> cur; // 存放当前组合的数组
        dfs(candidates, target, 0, cur, res); // 开始深度优先搜索
        return res;
    }

    void dfs(vector<int>& candidates, int target, int start, vector<int>& cur, vector<vector<int>>& res) {
        if (target == 0) { // 如果当前目标值为0,说明已经找到了一组组合,将其加入结果数组中
            res.push_back(cur);
            return;
        }
        for (int i = start; i < candidates.size(); i++) { // 从start开始遍历candidates数组
            if (candidates[i] > target) { // 如果当前数大于目标值,直接跳过
                continue;
            }
            cur.push_back(candidates[i]); // 将当前数加入当前组合中
            dfs(candidates, target - candidates[i], i, cur, res); // 继续搜索,目标值减去当前数,从当前数开始遍历
            cur.pop_back(); // 回溯,将当前数弹出当前组合
        }
    }
};

这道题的思路是使用深度优先搜索,从数组的第一个数开始搜索,每次搜索时,将当前数加入当前组合中,并将目标值减去当前数,继续搜索;如果当前目标值为0,说明已经找到了一组组合,将其加入结果数组中;如果当前数大于目标值,直接跳过,因为后面的数都比当前数大,不可能找到合法组合。搜索完当前数时,需要进行回溯,将当前数弹出当前组合,继续搜索下一个数。

Python代码

class Solution:
    def combinationSum(self, candidates: List[int], target: int) -> List[List[int]]:
        result = []
        path = []
        def dfs(start, tar):
            if tar == 0:
                result.append(path[:])
                return
            for i in range(start, len(candidates)):
                if candidates[i] > tar:
                    continue
                path.append(candidates[i])
                dfs(i, tar-candidates[i])
                path.pop()
        dfs(0, target)
        return result

这里的思路和 C++ 版本是一样的,使用深度优先搜索,从数组的第一个数开始搜索,每次搜索时,将当前数加入当前组合中,并将目标值减去当前数,继续搜索;如果当前目标值为0,说明已经找到了一组组合,将其加入结果数组中;如果当前数大于目标值,直接跳过,因为后面的数都比当前数大,不可能找到合法组合。搜索完当前数时,需要进行回溯,将当前数弹出当前组合,继续搜索下一个数。


文章作者: Jack Tim
版权声明: 本博客所有文章除特別声明外,均采用 CC BY 4.0 许可协议。转载请注明来源 Jack Tim !
评论
  目录